<?php
namespace WP_science\Engine\CDN\scienceCDN;

use WP_science\Dependencies\League\Container\ServiceProvider\AbstractServiceProvider;

/**
 * Service provider for scienceCDN
 *
 * @since 3.5
 */
class ServiceProvider extends AbstractServiceProvider {
	/**
	 * The provides array is a way to let the container
	 * know that a service is provided by this service
	 * provider. Every service that is registered via
	 * this service provider must have an alias added
	 * to this array or it will be ignored.
	 *
	 * @var array
	 */
	protected $provides = [
		'sciencecdn_api_client',
		'sciencecdn_options_manager',
		'sciencecdn_data_manager_subscriber',
		'sciencecdn_rest_subscriber',
		'sciencecdn_admin_subscriber',
		'sciencecdn_notices_subscriber',
	];

	/**
	 * Registers items with the container
	 *
	 * @return void
	 */
	public function register() {
		$options = $this->getContainer()->get( 'options' );
		// scienceCDN API Client.
		$this->getContainer()->add( 'sciencecdn_api_client', APIClient::class );
		// scienceCDN CDN options manager.
		$this->getContainer()->add( 'sciencecdn_options_manager', CDNOptionsManager::class )
			->addArgument( $this->getContainer()->get( 'options_api' ) )
			->addArgument( $options );
		// scienceCDN Data manager subscriber.
		$this->getContainer()->share( 'sciencecdn_data_manager_subscriber', DataManagerSubscriber::class )
			->addArgument( $this->getContainer()->get( 'sciencecdn_api_client' ) )
			->addArgument( $this->getContainer()->get( 'sciencecdn_options_manager' ) )
			->addTag( 'admin_subscriber' );
		// scienceCDN REST API Subscriber.
		$this->getContainer()->share( 'sciencecdn_rest_subscriber', RESTSubscriber::class )
			->addArgument( $this->getContainer()->get( 'sciencecdn_options_manager' ) )
			->addArgument( $options )
			->addTag( 'common_subscriber' );
		// scienceCDN Notices Subscriber.
		$this->getContainer()->share( 'sciencecdn_notices_subscriber', NoticesSubscriber::class )
			->addArgument( $this->getContainer()->get( 'sciencecdn_api_client' ) )
			->addArgument( $this->getContainer()->get( 'beacon' ) )
			->addArgument( __DIR__ . '/views' )
			->addTag( 'admin_subscriber' );
		// scienceCDN settings page subscriber.
		$this->getContainer()->share( 'sciencecdn_admin_subscriber', AdminPageSubscriber::class )
			->addArgument( $this->getContainer()->get( 'sciencecdn_api_client' ) )
			->addArgument( $options )
			->addArgument( $this->getContainer()->get( 'beacon' ) )
			->addArgument( __DIR__ . '/views' )
			->addTag( 'admin_subscriber' );
	}
}
